/**
 * 
 */
package edu.cmu.taghelpertools.middle_layer;

import java.io.Serializable;
import java.util.Set;
import java.util.TreeSet;

import edu.cmu.taghelpertools.tokenizer.Tokenizer;

/**
 * @author yichiaw
 *
 */
public class OptionsModel implements Serializable {
	private static final long serialVersionUID = -2335136163588228677L;
	public static int DEFAULT_LANG = Tokenizer.LANG_ENGLISH;
    private String selectedLanguage = Tokenizer.LANGS[OptionsModel.DEFAULT_LANG];
    private String stopwordListPath = Tokenizer.STPS[OptionsModel.DEFAULT_LANG];
	
	private Set<Integer> valuesN = new TreeSet<Integer>();
	private boolean posBigrams = true;
	private boolean lineLength = true;
	private boolean containsNonStopword = true;
	private boolean puctuation = true;
	private boolean stem = true;
	private boolean removeStopwords = true;
	private boolean all = true;
	public final static int DEFAULT_FREQ_THRESH = 3;
	private boolean removeRareFeatures = true;
	private int frequencyThreshold = OptionsModel.DEFAULT_FREQ_THRESH;
	
	public OptionsModel(){}
	public OptionsModel(String stopPath){
		stopwordListPath = stopPath;
	}
	
	public boolean isStopwordsAll(){
		return all;
	}
	
	public void setStopwordsAll(boolean a){
		all = a;
	}
	
    public boolean isUnigrams() {
        return valuesN.contains(1);
    }
    
    public void setUnigrams(boolean unigrams) {
        if(unigrams) addNGram(1); else removeNGram(1);
    }
    
    public boolean isBigrams() {
        return valuesN.contains(2);
    }

    public void addNGram(int n){
    	valuesN.add(n);
    }
    
    public void removeNGram(int n){
    	if(valuesN.contains(n)) valuesN.remove(n);
    }
    
    public Set<Integer> getNGrams(){
    	return valuesN;
    }
    
    public void setBigrams(boolean bigrams) {
        if(bigrams) addNGram(2); else removeNGram(2);
    }
    public void setTrigrams(boolean trigrams){
    	if(trigrams) addNGram(3); else removeNGram(3);
    }
    
    public boolean isPosBigrams() {
        return posBigrams;
    }

    public void setPosBigrams(boolean posBigrams) {
        this.posBigrams = posBigrams;
    }

    public boolean isLineLength() {
        return lineLength;
    }

    public void setLineLength(boolean lineLength) {
        this.lineLength = lineLength;
    }

    public boolean isContainsNonStopword() {
        return containsNonStopword;
    }

    public void setContainsNonStopword(boolean containsNonStopword) {
        this.containsNonStopword = containsNonStopword;
    }

    public boolean isPunctuation() {
        return puctuation;
    }

    public void setPunctuation(boolean puctuation) {
        this.puctuation = puctuation;
    }
    
    public boolean isStem() {
        return stem;
    }

    public void setStem(boolean stem) {
        this.stem = stem;
    }
    
    public boolean isRemoveStopwords() {
        return removeStopwords;
    }

    public void setRemoveStopwords(boolean removeStopwords) {
        this.removeStopwords = removeStopwords;
    }

    public boolean isRemoveRareFeatures() {
        return this.removeRareFeatures;
    }

    public void setRemoveRareFeatures(boolean removeRareFeatures) {
        this.removeRareFeatures = removeRareFeatures;
    }

    public void setFrequencyThreshold(int frequencyThreshold) {
        this.frequencyThreshold = frequencyThreshold;
    }
    
    public int getFrequencyThreshold() {
        return frequencyThreshold;
    }
        
    public String getLanguage()
    {
    	return this.selectedLanguage;
    }
    
    public String getStopwordListPath()
    {
      return this.stopwordListPath;	
    }
    
}
