package edu.cmu.taghelpertools.util;

//import org.upsam.grade.util.DLLChineseSegmenter;

//import edu.cmu.taghelpertools.tokenizer.ChineseTokenizer;
import edu.cmu.taghelpertools.tokenizer.Tokenizer;

public class HelperFunctions {

	public static String replacePuncWithSpecialTokens(String origText,
			String language) {
		return replacePuncWithSpecialTokens(origText, language, true, false);
	}
	
	public static String replacePuncWithSpecialTokens(String origText,
			String language, boolean withSpace, boolean lowerCase) {

		String text = new String(origText);
		text = text.trim();
		
		String space = "";
		if (withSpace) space = " ";
		
//		//	if the data is in Chinese, then do some basic language normalization first
//		if (language.equals(
//				Tokenizer.LANGS[Tokenizer.LANG_CHINESE])) {
//			text = DLLChineseSegmenter.doChineseSeg(text);
//			text = ChineseTokenizer.normalizeWhiteSpace(text);
//			text = ChineseTokenizer.removeParentheses(text);
//
//			text = ChineseTokenizer.normalizePunctuation(text);
//		}
		
		// english and german
		if (language.equals(
				Tokenizer.LANGS[Tokenizer.LANG_GERMAN]) || language.equals(
						Tokenizer.LANGS[Tokenizer.LANG_ENGLISH])) {
			
			if (lowerCase) {
				text = text.replaceAll("<", space + "<lessthan" + space);
				text = text.replaceAll(">", space + "<greaterthan>" + space);
				text = text.replaceAll(space + "<lessthan", space + "<lessthan>" + space);
				text = text.replaceAll(",", space + "<comma>" + space);
				text = text.replaceAll("\\.", space + "<period>" + space);
				text = text.replaceAll(";", space + "<semicolon>" + space);
				text = text.replaceAll(":", space + "<colon>" + space);
				text = text.replaceAll("-", space + "<dash>" + space);
				text = text.replaceAll("\\?", space + "<questionmark>" + space);
				text = text.replaceAll("!", space + "<exclamationmark>" + space);
				text = text.replaceAll("\\*", space + "<asterisk>" + space);
				text = text.replaceAll("&", space + "<ampersand>" + space);
				text = text.replaceAll("@", space + "<atsign>" + space);
				text = text.replaceAll("#", space + "<numbersign>" + space);
				text = text.replaceAll("%", space + "<percentsign>" + space);
				text = text.replaceAll("\\(", space + "<openparen>" + space);
				text = text.replaceAll("\\)", space + "<closeparen>" + space);
				text = text.replaceAll("\\{", space + "<opencurly>" + space);
				text = text.replaceAll("\\}", space + "<closecurly>" + space);
				text = text.replaceAll("\"", space + "<doublequote>" + space);
				text = text.replaceAll("\\$", space + "<dollar>" + space);
				text = text.replaceAll("\\\\", space + "<backslash>" + space);
				text = text.replaceAll("\\/", space + "<forwardslash>" + space);
				text = text.replaceAll("\\+", space + "<plussign>" + space);
				text = text.replaceAll("\\~", space + "<tilde>" + space);
				text = text.replaceAll("\\^", space + "<carat>" + space);
				text = text.replaceAll("\\[", space + "<leftsquareparen>" + space);
				text = text.replaceAll("\\]", space + "<rightsquareparen>" + space);
			} else {
				text = text.replaceAll("<", space + "<LESSTHAN" + space);
				text = text.replaceAll(">", space + "<GREATERTHAN>" + space);
				text = text.replaceAll(space + "<LESSTHAN", space + "<LESSTHAN>" + space);
				text = text.replaceAll(",", space + "<COMMA>" + space);
				text = text.replaceAll("\\.", space + "<PERIOD>" + space);
				text = text.replaceAll(";", space + "<SEMICOLON>" + space);
				text = text.replaceAll(":", space + "<COLON>" + space);
				text = text.replaceAll("-", space + "<DASH>" + space);
				text = text.replaceAll("\\?", space + "<QUESTIONMARK>" + space);
				text = text.replaceAll("!", space + "<EXCLAMATIONMARK>" + space);
				text = text.replaceAll("\\*", space + "<ASTERISK>" + space);
				text = text.replaceAll("&", space + "<AMPERSAND>" + space);
				text = text.replaceAll("@", space + "<ATSIGN>" + space);
				text = text.replaceAll("#", space + "<NUMBERSIGN>" + space);
				text = text.replaceAll("%", space + "<PERCENTSIGN>" + space);
				text = text.replaceAll("\\(", space + "<OPENPAREN>" + space);
				text = text.replaceAll("\\)", space + "<CLOSEPAREN>" + space);
				text = text.replaceAll("\\{", space + "<OPENCURLY>" + space);
				text = text.replaceAll("\\}", space + "<CLOSECURLY>" + space);
				text = text.replaceAll("\"", space + "<DOUBLEQUOTE>" + space);
				text = text.replaceAll("\\$", space + "<DOLLAR>" + space);
				text = text.replaceAll("\\\\", space + "<BACKSLASH>" + space);
				text = text.replaceAll("\\/", space + "<FORWARDSLASH>" + space);
				text = text.replaceAll("\\+", space + "<PLUSSIGN>" + space);
				text = text.replaceAll("~", space + "<TILDE>" + space);
				text = text.replaceAll("\\^", space + "<CARAT>" + space);
				text = text.replaceAll("\\[", space + "<LEFTSQUAREPAREN>" + space);
				text = text.replaceAll("\\]", space + "<RIGHTSQUAREPAREN>" + space);
			}
		}
		
		// german
		if (language.equals(
				Tokenizer.LANGS[Tokenizer.LANG_GERMAN])) {
//			text = text.replaceAll("�", "ae");
//			text = text.replaceAll("�", "Ae");
//			text = text.replaceAll("�", "oe");
//			text = text.replaceAll("�", "Oe");
//			text = text.replaceAll("�", "ue");
//			text = text.replaceAll("�", "Ue");
//			text = text.replaceAll("�", "ss");
			
			text = text.replaceAll("", "ae");
			text = text.replaceAll("", "Ae");
			text = text.replaceAll("", "oe");
			text = text.replaceAll("", "Oe");				
			text = text.replaceAll("", "ue");
			text = text.replaceAll("", "Ue");
			text = text.replaceAll("", "ss");

		}

		return text;
	}

	public static String replaceSpecialTokensWithPunc(String origText,
			String language) {

		String text = new String(origText);
		text = text.trim();
		
		// english and german
		if (language.equals(
				Tokenizer.LANGS[Tokenizer.LANG_GERMAN]) || language.equals(
						Tokenizer.LANGS[Tokenizer.LANG_ENGLISH])) {
			text = text.replaceAll("<LESSTHAN>", "<");
			text = text.replaceAll("<GREATERTHAN>", ">");
			text = text.replaceAll("<COMMA>", ",");
			text = text.replaceAll("<PERIOD>", ".");
			text = text.replaceAll("<SEMICOLON>", ";");
			text = text.replaceAll("<COLON>", ":");
			text = text.replaceAll("<DASH>", "-");
			text = text.replaceAll("<QUESTIONMARK>", "?");
			text = text.replaceAll("<EXCLAMATIONMARK>", "!");
			text = text.replaceAll("<ASTERISK>", "*");
			text = text.replaceAll("<AMPERSAND>", "&");
			text = text.replaceAll("<ATSIGN>", "@");
			text = text.replaceAll("<NUMBERSIGN>", "#");
			text = text.replaceAll("<PERCENTSIGN>", "%");
			text = text.replaceAll("<OPENPAREN>", "(");
			text = text.replaceAll("<CLOSEPAREN>", ")");
			text = text.replaceAll("<OPENCURLY>", "{");
			text = text.replaceAll("<CLOSECURLY>", "}");
			text = text.replaceAll("<DOUBLEQUOTE>", "\"");
			text = text.replaceAll("<DOLLAR>", "\\$");
			text = text.replaceAll("<BACKSLASH>", "\\\\");
			text = text.replaceAll("<FORWARDSLASH>", "/");
			text = text.replaceAll("<PLUSSIGN>", "+");
			text = text.replaceAll("<TILDE>", "~");
			text = text.replaceAll("<CARAT>", "^");
			text = text.replaceAll("<LEFTSQUAREPAREN>", "[");
			text = text.replaceAll("<RIGHTSQUAREPAREN>", "]");
		}
		
		return text;
	}
	
}
