package plugin.simple.features;

import java.awt.Component;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;
import java.util.TreeMap;

import javax.swing.JLabel;
import javax.swing.JPanel;

import org.w3c.dom.Element;

import edu.cmu.side.dataitem.DocumentListInterface;
import edu.cmu.side.simple.FeaturePlugin;
import edu.cmu.side.simple.feature.Feature;
import edu.cmu.side.simple.feature.FeatureHit;

public class Metafeatures extends FeaturePlugin{

	@Override
	public Collection<FeatureHit> extractFeatureHitsForSubclass(
			DocumentListInterface documents, JLabel progress) {
		Collection<FeatureHit> hits = new HashSet<FeatureHit>();
		ArrayList<String> annot = documents.getAnnotationArray();
		for(String name : documents.allAnnotations().keySet()){
			if(halt){
				halt = false;
				return null;
			}
			progress.setText("Adding feature for column " + name);
			try{
				ArrayList<String> features = documents.allAnnotations().get(name);
				ArrayList<Double> doubles = new ArrayList<Double>();
				if(features != annot){
					Feature.Type type = Feature.Type.NUMERIC;
					boolean alwaysBoolean = true;
					for(int i = 0; i < features.size(); i++){

						if(!(features.get(i).trim().equalsIgnoreCase("true")||features.get(i).trim().equalsIgnoreCase("false"))){
							alwaysBoolean = false;
						}
						try{
							Double d = Double.parseDouble(features.get(i).trim());
							doubles.add(d);
						}catch(Exception e){
							type = Feature.Type.NOMINAL;
						}
					}
					if(alwaysBoolean){
						type = Feature.Type.BOOLEAN;
					}
					Feature f;
					if(type == Feature.Type.NOMINAL){
						Set<String> values = new HashSet<String>();
						for(int i = 0; i < features.size(); i++){
							values.add(features.get(i));
						}
						f = Feature.fetchFeature(getOutputName(), name, values);
					}else{
						f = Feature.fetchFeature(getOutputName(), name, type);
					}
					for(int i = 0; i < features.size(); i++){
						switch(type){
						case NOMINAL:
							hits.add(new FeatureHit(f,features.get(i),i));
							break;
						case NUMERIC:
							if(doubles.get(i) != 0){
								hits.add(new FeatureHit(f,doubles.get(i),i));								
							}
							break;
						case BOOLEAN:
							if(features.get(i).trim().equalsIgnoreCase("true")){
								hits.add(new FeatureHit(f,Boolean.TRUE,i));
							}
							break;
						}
					}
				}
			}catch(Exception e){
				e.printStackTrace();
			}
		}
		progress.setText("");
		return hits;
	}

	@Override
	public String toString(){
		return "Metafeatures";
	}

	@Override
	public String getOutputName() {
		return "mt";
	}

	@Override
	protected Component getConfigurationUIForSubclass() {
		return new JPanel();
	}

}
