package plugin.simple.features;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.TreeMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;

import org.w3c.dom.Element;

import se.datadosen.component.RiverLayout;

import edu.cmu.side.dataitem.DocumentListInterface;
import edu.cmu.side.simple.FeaturePlugin;
import edu.cmu.side.simple.feature.Feature;
import edu.cmu.side.simple.feature.FeatureHit;
import edu.cmu.side.simple.feature.Feature.Type;

public class RegexSearch extends FeaturePlugin{
	JPanel searchPanel = new JPanel(new RiverLayout());
	JTextField newPatternField = new JTextField(30);
	JButton addPattern = new JButton("Add");
	JButton deletePattern = new JButton("Delete");
	JList addedPatterns = new JList();

	public RegexSearch(){

		addedPatterns.setModel(new DefaultListModel());
		searchPanel.add("left hfill", newPatternField);
		searchPanel.add("right", addPattern);
		addPattern.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				((DefaultListModel)(addedPatterns.getModel())).addElement(newPatternField.getText());
				newPatternField.setText("");
				searchPanel.repaint();
			}
		});
		JScrollPane scroll = new JScrollPane(addedPatterns);
		scroll.setPreferredSize(new Dimension(450,150));
		searchPanel.add("br hfill vfill", scroll);
		searchPanel.add("br right", deletePattern);
		deletePattern.addActionListener(new ActionListener(){
			@Override
			public void actionPerformed(ActionEvent e){
				int[] sel = addedPatterns.getSelectedIndices();
				for(int i = sel.length-1; i >= 0; i--){
					((DefaultListModel)addedPatterns.getModel()).remove(i);
				}
				searchPanel.repaint();
			}
		});
	}
	@Override
	public Collection<FeatureHit> extractFeatureHitsForSubclass(
			DocumentListInterface documents, JLabel progress) {
		Set<FeatureHit> hits = new HashSet<FeatureHit>();
		for(int i = 0; i < addedPatterns.getModel().getSize(); i++){
			String p = addedPatterns.getModel().getElementAt(i).toString();
			Feature f = Feature.fetchFeature(getOutputName(), p, Type.BOOLEAN);
			Pattern pattern = Pattern.compile(p);
			List<String> corpus = documents.getCoveredTextList();
			for(int j = 0; j < corpus.size(); j++){
				progress.setText("Pattern " + i + ", document " + j);
				Matcher m = pattern.matcher(corpus.get(j));
				if(m.find()){
					hits.add(new FeatureHit(f, true, j));
				}
			}
		}
		progress.setText("");
		return hits;
	}

	@Override
	public String toString(){
		return "Regex Search";
	}

	@Override
	public String getOutputName() {
		return "rx";
	}

	@Override
	protected Component getConfigurationUIForSubclass() {
		return searchPanel;
	}


}
